/******************************************
    slight_* Library Helper
        for more information see slight_*.cpp
    written by stefan krueger (s-light),
        git@s-light.eu, http://s-light.eu, https://github.com/s-light/
******************************************/

/******************************************
license

------------------------------------------
Apache License Version 2.0
Copyright 2019 Stefan Krueger

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

------------------------------------------
The MIT License (MIT)

Copyright (c) 2019 Stefan Krüger

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
https://opensource.org/licenses/mit-license.php
******************************************/

//Check if this class is already there or if it must be created...
#ifndef slight_FIX__THROW_BAD_FUNCTION_CALL_h
#define slight_FIX__THROW_BAD_FUNCTION_CALL_h

#if defined(ARDUINO_ARCH_SAMD) || defined(ARDUINO_ARCH_ESP32)
    #pragma GCC diagnostic push
    // #pragma GCC diagnostic ignored "-Wnoreturn"
    #pragma GCC diagnostic ignored "-Wsuggest-attribute=noreturn"
    // fix
    // undefined reference to `std::__throw_bad_function_call()'
    // found at
    // https://forum.arduino.cc/index.php?topic=382211.msg2790687#msg2790687
    namespace std {
        void __throw_bad_function_call() {
            Serial.println(F("STL ERROR - __throw_bad_function_call"));
        }
    }
    // but results in
    // warning: 'noreturn' function does return [enabled by default]
    // to hide this we try to ignore the *** for this code block..
    // *** i did not find the correct  ignore flag...
    // http://gcc.gnu.org/onlinedocs/gcc/Diagnostic-Pragmas.html
    // and
    // multiple definition of `std::__throw_bad_function_call()'
    // if we include it normally - with this Helper it works..
    #pragma GCC diagnostic pop
#endif

#endif // ifndef slight_FIX__THROW_BAD_FUNCTION_CALL_h

/** the end **/
